'Objetivo: 
'Este componente permite dar mostrar un men genrico en los
'los formularios de la Aplicacin.
'   1- Se Agrega un textbox, para permitir la bsqueda de los datos.
'   2- Se agrega un nuevo botn "Editar el cual permite la edicin de la informacin de un 
'      formulario"
'   3- Se elimina el procedimiento para habilitar o deshabilitar Botones del men.
'   4- Se agregar las siguientes propiedades, las cuales pueden ser modificadas en
'      tiempo de ejecucin.
'           Permitir_Agregar, Permitir_Guardar, Permitir_Cancelar,  Permitir_Editar
'           Permitir_Eliminar, Permitir_Desplazar_Primero,  Permitir_Desplazar_Anterior
'           Permitir_Desplazar_Siguiente, Permitir_Desplazar_Ultimo, 
'           Permitir_Texto_Busqueda, Permitir_Buscar, Permitir_Imprimir
'       Todas estas funciones son de lectura y escritura y aceptan valor booleano.
'   5- Se agrega una propiedad de solo lectura, que se llama Valor_del_Textbox, que 
'      es del tipo STRING, y retorna el valor de la caja de Texto
'   6- Se agregan los procedimientos publicos.
'       a- Editar_Elemento.
'       b- Agregar_Nuevo_Item.
'       c- Guardar_Cancelar
'   Todos estos procedimentos son publicos.
'=======================================================================================
'Imports System.Data.SqlClient
'Imports System.Net.Mail
'Imports System.Drawing.Drawing2D
Public Class MenuGenerico
    Inherits System.Windows.Forms.UserControl
    '-------------------- variables para el control
    Public Event BarraHaceClick(ByVal Boton As String)
    'Nombre : BarraHaceClick
    'Objetivo: 
    'Este es el evento que me permite la interaccin del control con los 
    'formularios en los que se aplique, recibe como parmetro en nombre
    'del botn que se ha presionado.
#Region "Propiedades"
    'Nombre : Region "PROPIEDADES"
    'Objetivo: 
    'Esta regin tiene como objetivo agrupar todas las propiedades del control.
    'En este apartado para un futuro es donde se deben ubicar todas las propiedades
    'del control.
    'En caso de que alguna de las propiedades aqu programadas quedara obsoleta, por
    'favor no eliminarla.
    'De aqu en adelante van las revisiones de esta Regin
    Public ReadOnly Property Valor_del_Textbox() As String
        'Nombre : Valor_del_Textbox
        'Detalle de la Propiedad
        '   Tipo de Datos: STRING.
        '   Lectura / Escritura: Solo lectura.
        '   Visibilidad : Publica.
        'Objetivo: 
        ' Propiedad de solo lectura, que permite retornar al programa principal
        ' el valor contenido en la caja de Textbox  "txt_buscar", que se encuentra en el 
        ' men principal.
        Get
            Return Me.mnu_generico.Items(11).Text ' Retorna el valor del campo.
        End Get
    End Property
    Public Property Permitir_Agregar() As Boolean
        'Nombre : Permitir_Agregar
        'Detalle de la Propiedad
        '   Tipo de Datos: BOOOLEAN.
        '   Lectura / Escritura: AMBAS.
        '   Visibilidad : Publica.
        '   Valor Predeterminado : TRUE
        'Objetivo: 
        ' Esta propiedad permite que el Boton para agregar elementos se muestre como
        ' activo o inactivo. nicamente acepta valores booleanos. Su estado puede
        ' ser modificado en tiempo de diseo y ejecucin.
        Get
            Return mnu_generico.Items(0).Enabled 'retorna el valor del objeto
        End Get
        Set(ByVal value As Boolean)
            mnu_generico.Items(0).Enabled = value 'asigna el valor al objeto
        End Set
    End Property
    Public Property Permitir_Guardar() As Boolean
        'Nombre : Permitir_Guardar
        'Detalle de la Propiedad
        '   Tipo de Datos: BOOOLEAN.
        '   Lectura / Escritura: AMBAS.
        '   Visibilidad : Publica.
        '   Valor Predeterminado : FALSE
        'Objetivo: 
        ' Esta propiedad permite que el Boton para guardar elementos se muestre como
        ' activo o inactivo. nicamente acepta valores booleanos. Su estado puede
        ' ser modificado en tiempo de diseo y ejecucin.
        Get
            Return mnu_generico.Items(1).Enabled 'Retorna el valor actual del objeto
        End Get
        Set(ByVal value As Boolean)
            mnu_generico.Items(1).Enabled = value 'establece el nuevo valor del objeto
        End Set
    End Property
    Public Property Permitir_Cancelar() As Boolean
        'Nombre : Permitir_Cancelar
        'Detalle de la Propiedad
        '   Tipo de Datos: BOOOLEAN.
        '   Lectura / Escritura: AMBAS.
        '   Visibilidad : Publica.
        '   Valor Predeterminado : FALSE
        'Objetivo: 
        ' Esta propiedad permite que el Boton para cancelar los cambios realizados
        ' se muestre como activo o inactivo. nicamente acepta valores booleanos. 
        ' Su estado puede
        ' ser modificado en tiempo de diseo y ejecucin.
        Get
            Return mnu_generico.Items(2).Enabled
        End Get
        Set(ByVal value As Boolean)
            mnu_generico.Items(2).Enabled = value
        End Set
    End Property
    Public Property Permitir_Editar() As Boolean
        'Nombre : Permitir_Editar
        'Detalle de la Propiedad
        '   Tipo de Datos: BOOOLEAN.
        '   Lectura / Escritura: AMBAS.
        '   Visibilidad : Publica.
        '   Valor Predeterminado : TRUE
        'Objetivo: 
        ' Esta propiedad permite que el Boton para Editar los elementos
        ' se muestre como activo o inactivo. nicamente acepta valores booleanos. 
        ' Su estado puede
        ' ser modificado en tiempo de diseo y ejecucin.
        Get
            Return mnu_generico.Items(3).Enabled
        End Get
        Set(ByVal value As Boolean)
            mnu_generico.Items(3).Enabled = value
        End Set
    End Property
    Public Property Permitir_Eliminar() As Boolean
        'Nombre : Permitir_Eliminar
        'Detalle de la Propiedad
        '   Tipo de Datos: BOOOLEAN.
        '   Lectura / Escritura: AMBAS.
        '   Visibilidad : Publica.
        '   Valor Predeterminado : TRUE
        'Objetivo: 
        ' Esta propiedad permite que el Boton para eliminar datos
        ' se muestre como activo o inactivo. nicamente acepta valores booleanos. 
        ' Su estado puede
        ' ser modificado en tiempo de diseo y ejecucin.
        Get
            Return mnu_generico.Items(4).Enabled
        End Get
        Set(ByVal value As Boolean)
            mnu_generico.Items(4).Enabled = value
        End Set
    End Property
    Public Property Permitir_Desplazar_Primero() As Boolean
        'Nombre : Permitir_Desplazar_Primero
        'Detalle de la Propiedad
        '   Tipo de Datos: BOOOLEAN.
        '   Lectura / Escritura: AMBAS.
        '   Visibilidad : Publica.
        '   Valor Predeterminado : TRUE
        'Objetivo: 
        ' Esta propiedad permite que el Boton para el desplazamiento al inicio de los 
        ' datos contenidos en un  DataSet se muestre como activo o inactivo. 
        ' nicamente acepta valores booleanos. 
        ' Su estado puede
        ' ser modificado en tiempo de diseo y ejecucin.
        Get
            Return mnu_generico.Items(6).Enabled
        End Get
        Set(ByVal value As Boolean)
            mnu_generico.Items(6).Enabled = value
        End Set
    End Property
    Public Property Permitir_Desplazar_Anterior() As Boolean
        'Nombre : Permitir_Desplazar_Anterior
        'Detalle de la Propiedad
        '   Tipo de Datos: BOOOLEAN.
        '   Lectura / Escritura: AMBAS.
        '   Visibilidad : Publica.
        '   Valor Predeterminado : TRUE
        'Objetivo: 
        ' Esta propiedad permite que el Boton para el desplazamiento  a la posicin anterior
        ' de la actual dentro de un DataSet se muestre como activo o inactivo. 
        ' nicamente acepta valores booleanos. 
        ' Su estado puede
        ' ser modificado en tiempo de diseo y ejecucin.
        Get
            Return mnu_generico.Items(7).Enabled
        End Get
        Set(ByVal value As Boolean)
            mnu_generico.Items(7).Enabled = value
        End Set
    End Property
    Public Property Permitir_Desplazar_Siguiente() As Boolean
        'Nombre : Permitir_Desplazar_Siguiente
        'Detalle de la Propiedad
        '   Tipo de Datos: BOOOLEAN.
        '   Lectura / Escritura: AMBAS.
        '   Visibilidad : Publica.
        '   Valor Predeterminado : TRUE
        'Objetivo: 
        ' Esta propiedad permite que el Boton para el desplazamiento  a la posicin siguiente
        ' de la actual dentro de un DataSet se muestre como activo o inactivo. 
        ' nicamente acepta valores booleanos. 
        ' Su estado puede
        ' ser modificado en tiempo de diseo y ejecucin.
        Get
            Return mnu_generico.Items(8).Enabled
        End Get
        Set(ByVal value As Boolean)
            mnu_generico.Items(8).Enabled = value
        End Set
    End Property
    Public Property Permitir_Desplazar_Ultimo() As Boolean
        'Nombre : Permitir_Desplazar_Ultimo
        'Detalle de la Propiedad
        '   Tipo de Datos: BOOOLEAN.
        '   Lectura / Escritura: AMBAS.
        '   Visibilidad : Publica.
        '   Valor Predeterminado : TRUE
        'Objetivo: 
        ' Esta propiedad permite que el Boton para el desplazamiento  a la ultimo posicin
        ' de la actual dentro de un DataSet se muestre como activo o inactivo. 
        ' nicamente acepta valores booleanos. 
        ' Su estado puede
        ' ser modificado en tiempo de diseo y ejecucin.

        Get
            Return mnu_generico.Items(9).Enabled
        End Get
        Set(ByVal value As Boolean)
            mnu_generico.Items(9).Enabled = value
        End Set
    End Property
    Public Property Permitir_Texto_Busqueda() As Boolean
        'Nombre : Permitir_Texto_Busqueda
        'Detalle de la Propiedad
        '   Tipo de Datos: BOOOLEAN.
        '   Lectura / Escritura: AMBAS.
        '   Visibilidad : Publica.
        '   Valor Predeterminado : TRUE
        'Objetivo: 
        ' Esta propiedad permite que  el campo para ingresar el texto de la 
        ' bsqueda se muestre como activo o inactivo. 
        ' nicamente acepta valores booleanos. 
        ' Su estado puede
        ' ser modificado en tiempo de diseo y ejecucin.
        Get
            Return mnu_generico.Items(11).Enabled
        End Get
        Set(ByVal value As Boolean)
            mnu_generico.Items(11).Enabled = value
        End Set
    End Property
    Public Property Permitir_Buscar() As Boolean
        'Nombre : Permitir_Buscar
        'Detalle de la Propiedad
        '   Tipo de Datos: BOOOLEAN.
        '   Lectura / Escritura: AMBAS.
        '   Visibilidad : Publica.
        '   Valor Predeterminado : TRUE
        'Objetivo: 
        ' Esta propiedad permite que el Boton para realizar las bsquedas se muestre 
        ' como activo o inactivo. 
        ' nicamente acepta valores booleanos. 
        ' Su estado puede
        ' ser modificado en tiempo de diseo y ejecucin.
        Get
            Return mnu_generico.Items(13).Enabled
        End Get
        Set(ByVal value As Boolean)
            mnu_generico.Items(13).Enabled = value
        End Set
    End Property
    Public Property Permitir_Imprimir() As Boolean
        'Nombre : Permitir_Imprimir
        'Detalle de la Propiedad
        '   Tipo de Datos: BOOOLEAN.
        '   Lectura / Escritura: AMBAS.
        '   Visibilidad : Publica.
        '   Valor Predeterminado : TRUE
        'Objetivo: 
        ' Esta propiedad permite que el Boton para realizar las impresiones se muestre 
        ' como activo o inactivo. 
        ' nicamente acepta valores booleanos. 
        ' Su estado puede
        ' ser modificado en tiempo de diseo y ejecucin.
        Get
            Return mnu_generico.Items(14).Enabled
        End Get
        Set(ByVal value As Boolean)
            mnu_generico.Items(14).Enabled = value
        End Set
    End Property
#End Region
#Region "Procedimientos"
    'Nombre : Region "Procedimientos"
    'Objetivo: 
    'Esta regin tiene como objetivo agrupar todas los procedimientos y
    'funciones propias del control.
    'En este apartado para un futuro es donde se deben ubicar todas los procedimientos
    ' y funciones del control.
    'En caso de que algunos de estos quedaran obsoletos, por
    'favor no eliminarlos.
    'De aqu en adelante van las revisiones de esta Regin
    Public Sub Editar_Elemento()
        'Nombre : Editar_Elemento
        'Detalle del procedimiento
        '   Visibilidad : Publica.
        'Objetivo: 
        ' Este procedimiento tiene como fin habilitar o deshabilitar Botones del men
        ' segn sea necesario.
        ' Es visible desde el formulario que se esta usuario. Y se debe utilizar para
        ' cuando se realizan bsquedas de datos, ya que si son encontrados habilita los
        ' Botones para  guardar y cancelar, asi como los Botones de desplazamiento.
        '-------- habilitar los Botones
        Me.Permitir_Guardar = True   'habilita para guardar
        Me.Permitir_Cancelar = True 'habilita para cancelar
        Me.Permitir_Desplazar_Primero = True 'barra de desplazamiento al principio
        Me.Permitir_Desplazar_Anterior = True 'barra de desplazamiento al anterio
        Me.Permitir_Desplazar_Siguiente = True 'barra de desplazamiento al siguiente
        Me.Permitir_Desplazar_Ultimo = True 'barra desplazamiento al final.
        '---------- inhabilitar los Botones
        Me.Permitir_Agregar = False 'inhabilita agregar nuevos
        Me.Permitir_Buscar = False 'inhabilita la bsqueda
        Me.Permitir_Editar = False 'inhabilita la edicin 
        Me.Permitir_Eliminar = False 'inhabilitar eliminar datos
        Me.Permitir_Imprimir = False ' inhabilita la impresion
        Me.Permitir_Texto_Busqueda = False 'inhabilita el texto para las bsquedas
    End Sub
    Public Sub Agregar_Nuevo_Item()
        'Nombre : Agregar_Nuevo_Item
        'Detalle del procedimiento
        '   Visibilidad : Publica.
        'Objetivo: 
        ' Este procedimiento tiene como fin habilitar o deshabilitar Botones del men
        ' segn sea necesario.
        ' Es visible desde el formulario que se esta usuario. Y se debe utilizar para
        ' cuando se realizan bsquedas de datos, ya que si no son encontrados habilita los
        ' Botones para  guardar y cancelar.
        txt_buscar.Text = ""
        '-------- habilitar los Botones
        Me.Permitir_Guardar = True 'habilita para guardar
        Me.Permitir_Cancelar = True 'habilita para cancelar
        '---------- inhabilitar los Botones
        Me.Permitir_Agregar = False 'inhabilita agregar nuevos
        Me.Permitir_Buscar = False 'inhabilita la bsqueda
        Me.Permitir_Editar = False 'inhabilita la edicin 
        Me.Permitir_Eliminar = False 'inhabilitar eliminar datos
        Me.Permitir_Imprimir = False ' inhabilita la impresion
        Me.Permitir_Texto_Busqueda = False 'inhabilita el texto para las bsquedas
        Me.Permitir_Desplazar_Primero = False 'barra de desplazamiento al principio
        Me.Permitir_Desplazar_Anterior = False 'barra de desplazamiento al anterio
        Me.Permitir_Desplazar_Siguiente = False 'barra de desplazamiento al siguiente
        Me.Permitir_Desplazar_Ultimo = False 'barra desplazamiento al final.

    End Sub
    Public Sub Guardar_Cancelar()
        'Nombre : Guardar_Cancelar
        'Detalle del procedimiento
        '   Visibilidad : Publica.
        'Objetivo: 
        ' Este procedimiento tiene como fin habilitar o deshabilitar Botones del men
        ' segn sea necesario.
        ' Es visible desde el formulario que se esta usuario. Se usa para cada vez
        ' que se presionan los Botones de guardar y cancelar
        '-------- habilitar los Botones
        Me.Permitir_Agregar = True
        Me.Permitir_Buscar = True
        Me.Permitir_Editar = True
        Me.Permitir_Eliminar = True
        Me.Permitir_Imprimir = True
        Me.Permitir_Texto_Busqueda = True
        Me.Permitir_Desplazar_Primero = True
        Me.Permitir_Desplazar_Anterior = True
        Me.Permitir_Desplazar_Siguiente = True
        Me.Permitir_Desplazar_Ultimo = True
        '---------- inhabilitar los Botones
        Me.Permitir_Guardar = False
        Me.Permitir_Cancelar = False
    End Sub
#End Region

    Private Sub mnu_generico_ItemClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ToolStripItemClickedEventArgs) Handles mnu_generico.ItemClicked
        Select Case mnu_generico.Items.IndexOf(e.ClickedItem)
            Case 0
                RaiseEvent BarraHaceClick("Nuevo")
                Agregar_Nuevo_Item()
            Case 1
                RaiseEvent BarraHaceClick("Guardar")
                Guardar_Cancelar()
            Case 2
                RaiseEvent BarraHaceClick("Cancelar")
                Guardar_Cancelar()
            Case 3
                RaiseEvent BarraHaceClick("Editar")
                Editar_Elemento()
            Case 4
                RaiseEvent BarraHaceClick("Borrar")
            Case 6
                RaiseEvent BarraHaceClick("Primero")
                Guardar_Cancelar()
            Case 7
                RaiseEvent BarraHaceClick("Anterior")
                Guardar_Cancelar()
            Case 8
                RaiseEvent BarraHaceClick("Siguiente")
                Guardar_Cancelar()
            Case 9
                RaiseEvent BarraHaceClick("Ultimo")
                Guardar_Cancelar()
            Case 13
                RaiseEvent BarraHaceClick("Buscar")
            Case 14
                RaiseEvent BarraHaceClick("Imprimir")
            Case 16
                RaiseEvent BarraHaceClick("Regresar")
            Case 17
                RaiseEvent BarraHaceClick("Ayuda")
        End Select
    End Sub
    Private Sub MenuGenerico_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Guardar_Cancelar()
        Me.Left = 0
        Me.Top = 0
    End Sub
    Private Sub txt_buscar_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_buscar.GotFocus
        txt_buscar.SelectionStart = 0
        txt_buscar.SelectionLength = Len(Trim$(txt_buscar.Text))
    End Sub
End Class



